"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from dataclasses_json import Undefined, dataclass_json
from enum import Enum
from log10 import utils
from typing import Optional


class ChatCompletionRequestMessageContentPartImageType(str, Enum):
    r"""The type of the content part."""
    IMAGE_URL = 'image_url'


class Detail(str, Enum):
    r"""Specifies the detail level of the image. Learn more in the [Vision guide](/docs/guides/vision/low-or-high-fidelity-image-understanding)."""
    AUTO = 'auto'
    LOW = 'low'
    HIGH = 'high'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class ImageURL:
    url: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('url') }})
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: Optional[Detail] = dataclasses.field(default=Detail.AUTO, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('detail'), 'exclude': lambda f: f is None }})
    r"""Specifies the detail level of the image. Learn more in the [Vision guide](/docs/guides/vision/low-or-high-fidelity-image-understanding)."""
    



@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class ChatCompletionRequestMessageContentPartImage:
    type: ChatCompletionRequestMessageContentPartImageType = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('type') }})
    r"""The type of the content part."""
    image_url: ImageURL = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('image_url') }})
    

